## ros-iron-rcl-yaml-param-parser 6.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl_yaml_param_parser)

find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(libyaml_vendor REQUIRED)
find_package(yaml REQUIRED)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(
    -Wall -Wextra -Wpedantic
    -Wformat=2 -Wconversion -Wsign-conversion
  )
endif()

add_library(
  ${PROJECT_NAME}
  src/add_to_arrays.c
  src/namespace.c
  src/node_params.c
  src/parse.c
  src/parser.c
  src/yaml_variant.c
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
target_link_libraries(${PROJECT_NAME} PUBLIC
  rcutils::rcutils
)
target_link_libraries(${PROJECT_NAME} PRIVATE
  rmw::rmw
  yaml
)

# Set the visibility to hidden by default if possible
if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  # Set the visibility of symbols to hidden by default for gcc and clang
  # (this is already the default on Windows)
  set_target_properties(${PROJECT_NAME}
    PROPERTIES
    COMPILE_FLAGS "-fvisibility=hidden"
  )
endif()

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_YAML_PARAM_PARSER_BUILDING_DLL")

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS
    performance_test_fixture::performance_test_fixture INTERFACE_INCLUDE_DIRECTORIES)

  # Gtests
  ament_add_gtest(test_namespace
    test/test_namespace.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_namespace)
    target_link_libraries(test_namespace
      ${PROJECT_NAME}
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
    )
    target_compile_definitions(test_namespace PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_node_params
    test/test_node_params.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_node_params)
    target_link_libraries(test_node_params
      ${PROJECT_NAME}
      rcutils::rcutils
    )
  endif()

  ament_add_gtest(test_parse_yaml
    test/test_parse_yaml.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_parse_yaml)
    target_link_libraries(test_parse_yaml
      ${PROJECT_NAME}
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
    )
    target_include_directories(test_parse_yaml
      PRIVATE ${osrf_testing_tools_cpp_INCLUDE_DIRS})
  endif()

  ament_add_gtest(test_parse
    test/test_parse.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_parse)
    target_link_libraries(test_parse
      ${PROJECT_NAME}
      mimick
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
      yaml
    )
  endif()

  ament_add_gtest(test_parser
    test/test_parser.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_parser)
    target_link_libraries(test_parser
      ${PROJECT_NAME}
      mimick
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
      yaml
    )
    target_compile_definitions(test_parser PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_parser_multiple_nodes
    test/test_parser_multiple_nodes.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    TIMEOUT 240  # Large timeout to wait for fault injection tests
  )
  if(TARGET test_parser_multiple_nodes)
    target_link_libraries(test_parser_multiple_nodes
      ${PROJECT_NAME}
      mimick
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
    )
    target_compile_definitions(test_parser_multiple_nodes PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_parser_multiple_params
    test/test_parser_multiple_params.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_parser_multiple_params)
    target_link_libraries(test_parser_multiple_params
      ${PROJECT_NAME}
      mimick
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
    )
    target_compile_definitions(test_parser_multiple_params PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_yaml_variant
    test/test_yaml_variant.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_yaml_variant)
    target_link_libraries(test_yaml_variant
      ${PROJECT_NAME}
      osrf_testing_tools_cpp::memory_tools
      rcutils::rcutils
    )
  endif()

  add_performance_test(benchmark_parse_yaml test/benchmark/benchmark_parse_yaml.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
  if(TARGET benchmark_parse_yaml)
    target_link_libraries(benchmark_parse_yaml
      ${PROJECT_NAME}
      performance_test_fixture::performance_test_fixture
      rcpputils::rcpputils
      rcutils::rcutils
    )
  endif()

  add_performance_test(benchmark_variant test/benchmark/benchmark_variant.cpp)
  if(TARGET benchmark_variant)
    target_link_libraries(benchmark_variant
      ${PROJECT_NAME}
      osrf_testing_tools_cpp::memory_tools
      performance_test_fixture::performance_test_fixture
      rcutils::rcutils
    )
  endif()
endif()

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_export_dependencies(ament_cmake rcutils)

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
ament_package()

=== debian/changelog ===
ros-iron-rcl-yaml-param-parser (6.0.3-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Thu, 07 Sep 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (6.0.2-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Thu, 18 May 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (6.0.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Mon, 17 Apr 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (6.0.0-1jammy) jammy; urgency=high

  * Fix some warnings from clang. (#1042 <https://github.com/ros2/rcl/issues/1042>)
  * Contributors: Chris Lalancette

 -- Audrow Nash <audrow@openrobotics.org>  Tue, 11 Apr 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.9.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Tue, 28 Feb 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.8.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 22 Feb 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.7.0-1jammy) jammy; urgency=high

  * Cleanup the dependencies in rcl_yaml_param_parser. (#1014 <https://github.com/ros2/rcl/issues/1014>)
  * Update rcl to C++17. (#1031 <https://github.com/ros2/rcl/issues/1031>)
  * Support yaml string tag '!!str' (#999 <https://github.com/ros2/rcl/issues/999>)
  * Contributors: Barry Xu, Chris Lalancette

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 12 Feb 2023 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.6.0-1jammy) jammy; urgency=high

  * [rolling] Update maintainers - 2022-11-07 (#1017 <https://github.com/ros2/rcl/issues/1017>)
  * Contributors: Audrow Nash

 -- Audrow Nash <audrow@openrobotics.org>  Sun, 04 Dec 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.5.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Tue, 01 Nov 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.4.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Mon, 12 Sep 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.4.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Thu, 28 Apr 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.3.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Mon, 25 Apr 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.3.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Mon, 04 Apr 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.2.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 30 Mar 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.2.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 23 Mar 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.1.0-1jammy) jammy; urgency=high

  * Install includes it include/${PROJECT_NAME} (#959 <https://github.com/ros2/rcl/issues/959>)
  * Contributors: Shane Loretz

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 28 Feb 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.0.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Thu, 13 Jan 2022 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (5.0.0-1jammy) jammy; urgency=high

  * Update maintainers to Ivan Paunovic and William Woodall (#952 <https://github.com/ros2/rcl/issues/952>)
  * Tweak rcl_yaml_param_parser documentation (#939 <https://github.com/ros2/rcl/issues/939>)
  * Contributors: Audrow Nash, Michel Hidalgo

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 13 Dec 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (4.0.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 15 Sep 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.2.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 01 Sep 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.1.2-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Sun, 25 Apr 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.1.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Sun, 11 Apr 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.1.0-1jammy) jammy; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#909 <https://github.com/ros2/rcl/issues/909>)
  * Contributors: shonigmann

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 05 Apr 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.0.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 24 Mar 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (3.0.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Mon, 22 Mar 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (2.6.0-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Wed, 17 Mar 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (2.5.2-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Thu, 04 Feb 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (2.5.1-1jammy) jammy; urgency=high



 -- Audrow Nash <audrow@openrobotics.org>  Sun, 24 Jan 2021 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (2.5.0-1jammy) jammy; urgency=high

  * Enable compiler warnings (#831 <https://github.com/ros2/rcl/issues/831>)
  * Update QDs to QL 1 (#866 <https://github.com/ros2/rcl/issues/866>)
  * Rearrange test logic to avoid reference to null (#862 <https://github.com/ros2/rcl/issues/862>)
  * Update QL (#858 <https://github.com/ros2/rcl/issues/858>)
  * Make sure to initialize the end_mark for yaml_event_t (#849 <https://github.com/ros2/rcl/issues/849>)
  * Contributors: Alejandro Hernández Cordero, Audrow Nash, Chris Lalancette, Stephen Brawner

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 07 Dec 2020 16:00:00 -0000

ros-iron-rcl-yaml-param-parser (2.4.0-1jammy) jammy; urgency=high

  * Check for valid node names in parameters files (#809 <https://github.com/ros2/rcl/issues/809>)


=== debian/control ===
Source: ros-iron-rcl-yaml-param-parser
Section: misc
Priority: optional
Maintainer: Audrow Nash <audrow@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libyaml-dev, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-libyaml-vendor, ros-iron-mimick-vendor <!nocheck>, ros-iron-osrf-testing-tools-cpp <!nocheck>, ros-iron-performance-test-fixture <!nocheck>, ros-iron-rcpputils <!nocheck>, ros-iron-rcutils, ros-iron-rmw, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rcl-yaml-param-parser
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-dev, ros-iron-libyaml-vendor, ros-iron-rcutils, ros-iron-rmw, ros-iron-ros-workspace
Description: Parse a YAML parameter file and populate the C data structure.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rcl-yaml-param-parser//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
